cookutils view cook @ rev 1002

cook: export CAT for mk_pkg_receipt; lighttpd/index.cgi: rename man2html to man2html.bin for package man2html availability, prepend diff output with vertical bar, improve coloring.
author Aleksej Bobylev <al.bobylev@gmail.com>
date Mon Nov 06 02:53:05 2017 +0200 (2017-11-06)
parents 41cc599aa328
children 75b330dd2734
line source
1 #!/bin/sh
2 #
3 # Cook - A tool to cook and generate SliTaz packages. Read the README
4 # before adding or modifying any code in cook!
5 #
6 # Copyright (C) SliTaz GNU/Linux - GNU GPL v3
7 # Author: Christophe Lincoln <pankso@slitaz.org>
8 #
10 . /usr/lib/slitaz/libcook.sh
12 VERSION="3.2"
13 export output=raw
16 # Internationalization.
18 export TEXTDOMAIN='cook'
21 #
22 # Functions
23 #
25 usage() {
26 cat <<EOT
28 $(boldify "$(_ 'Usage:')") $(_ 'cook [package|command] [list|--option]')
30 $(boldify "$(_ 'Commands:')")
31 usage|help $(_ 'Display this short usage.')
32 setup $(_ 'Setup your build environment.')
33 *-setup $(_ 'Setup a cross environment.')
34 * = {arm|armv6hf|armv7|x86_64}
35 test $(_ 'Test environment and cook a package.')
36 list-wok $(_ 'List packages in the wok.')
37 search $(_ 'Simple packages search function.')
38 new $(_ 'Create a new package with a receipt.')
39 list $(_ 'Cook a list of packages.')
40 clean-wok $(_ 'Clean-up all packages files.')
41 clean-src $(_ 'Clean-up all packages sources.')
42 uncook $(_ 'Check for uncooked packages')
43 pkgdb $(_ 'Create packages DB lists and flavors.')
45 $(boldify "$(_ 'Options:')")
46 cook <pkg>
47 --clean -c $(_ 'clean the package in the wok.')
48 --install -i $(_ 'cook and install the package.')
49 --getsrc -gs $(_ 'get the package source tarball.')
50 --block -b $(_ 'block a package so cook will skip it.')
51 --unblock -ub $(_ 'unblock a blocked package.')
52 --cdeps $(_ 'check dependencies of cooked package.')
53 --pack $(_ 'repack an already built package.')
54 --debug $(_ 'display debugging messages.')
55 --continue $(_ 'continue running compile_rules.')
56 cook new <pkg>
57 --interactive -x $(_ 'create a receipt interactively.')
58 cook setup
59 --wok $(_ 'clone the cooking wok from Hg repo.')
60 --stable $(_ 'clone the stable wok from Hg repo.')
61 --undigest $(_ 'clone the undigest wok from Hg repo.')
62 --tiny $(_ 'clone the tiny SliTaz wok from Hg repo.')
63 --forced $(_ 'force reinstall of chroot packages.')
64 cook pkgdb
65 --flavors $(_ 'create up-to-date flavors files.')
66 cook splitdb $(_ 'create up-to-date split.db file.')
68 EOT
69 exit 0
70 }
73 # We don't want these escapes in web interface.
75 clean_log() {
76 sed -i -e 's|\[70G\[ \[1;32m| |' \
77 -e 's|\[0;39m \]||' $LOGS/${1:-$pkg}.log
78 }
81 # Be sure package exists in wok.
83 check_pkg_in_wok() {
84 [ -d "$WOK/$pkg" ] || die 'Unable to find package "%s" in the wok' "$pkg"
85 }
88 # Initialize files used in $CACHE
90 init_db_files() {
91 _ 'Creating directories structure in "%s"' "$SLITAZ"
92 mkdir -p $WOK $PKGS $SRC $CACHE $LOGS $FEEDS
93 _ 'Creating DB files in "%s"' "$CACHE"
94 touch $activity $command $broken $blocked $CACHE/webstat
95 chown www:www $cache/webstat
96 }
99 # QA: check a receipt consistency before building.
101 receipt_quality() {
102 _ 'QA: checking package receipt...'
104 for var in PACKAGE VERSION CATEGORY SHORT_DESC MAINTAINER WEB_SITE; do
105 unset value
106 value="$(. $receipt; eval echo \$$var)"
107 # L10n: QA is quality assurance
108 [ -n "$value" ] || die 'QA: empty variable: %s' "$var=\"\""
110 case "$var" in
111 CATEGORY)
112 valid="$(echo $PKGS_CATEGORIES)" # avoid newlines
113 if ! echo " $valid " | grep -q " $value "; then
114 _ 'QA: unknown category "%s"' "$value"
115 die 'Please, use one of: %s' "$valid"
116 fi
117 ;;
118 WEB_SITE)
119 # We don't check WGET_URL since if dl is needed it will fail.
120 # Break also if we're not online. Here error is not fatal.
121 if ifconfig | grep -A1 '^[a-z]*[0-9]' | fgrep -q 'addr:' && \
122 ! busybox wget -T 12 --spider $value 2>/dev/null; then
123 _ 'QA: unable to reach "%s"' "$value"
124 fi
125 ;;
126 esac
127 done
128 }
131 # Paths used in receipt and by cook itself.
133 set_paths() {
134 pkgdir="$WOK/$pkg"
135 . "$pkgdir/receipt"
136 basesrc="$pkgdir/source"
137 tmpsrc="$basesrc/tmp"
138 src="$basesrc/$PACKAGE-$VERSION"
139 taz="$pkgdir/taz"
140 pack="$taz/${1:-$PACKAGE}-$VERSION$EXTRAVERSION" # v2: multiple taz/* folders
141 fs="$pack/fs"
142 stuff="$pkgdir/stuff"
143 install="$pkgdir/install"
145 pkgsrc="${SOURCE:-$PACKAGE}-${KBASEVER:-$VERSION}"
146 lzma_tarball="$pkgsrc.tar.lzma"
148 [ -n "$PATCH" -a -z "$PTARBALL" ] && PTARBALL="$(basename $PATCH)"
150 if [ -n "$WANTED" ]; then
151 basesrc="$WOK/$WANTED/source"
152 src="$basesrc/$WANTED-$VERSION"
153 install="$WOK/$WANTED/install"
154 wanted_stuff="$WOK/$WANTED/stuff"
155 fi
157 [ -n "$SOURCE" ] && source_stuff="$WOK/$SOURCE/stuff"
159 # Kernel version is set from wok/linux or installed/linux-api-headers(wok-undigest)
160 if [ -f "$WOK/linux/receipt" ]; then
161 kvers=$(. $WOK/linux/receipt; echo $VERSION)
162 kbasevers=$(echo $kvers | cut -d. -f1,2)
163 elif [ -f "$INSTALLED/linux-api-headers/receipt" ]; then
164 kvers=$(. $INSTALLED/linux-api-headers/receipt; echo $VERSION)
165 kbasevers=$(echo $kvers | cut -d. -f1,2)
166 fi
168 # Python version
169 [ -f "$WOK/python/receipt" ] && pyvers=$(. $WOK/python/receipt; echo $VERSION)
170 # Perl version for some packages needed it
171 [ -f "$WOK/perl/receipt" ] && perlvers=$(. $WOK/perl/receipt; echo $VERSION)
173 # Old way compatibility.
174 _pkg="$install"
175 }
178 # Create source tarball when URL is a SCM.
180 create_tarball() {
181 local tarball
182 tarball="$pkgsrc.tar.bz2"
183 [ -n "$LZMA_SRC" ] && tarball="$lzma_tarball"
184 _ 'Creating tarball "%s"' "$tarball"
185 if [ -n "$LZMA_SRC" ]; then
186 tar -c $pkgsrc | lzma e $SRC/$tarball -si $LZMA_SET_DIR || exit 1
187 LZMA_SRC=''
188 else
189 tar -cjf $tarball $pkgsrc || exit 1
190 mv $tarball $SRC; rm -rf $pkgsrc
191 fi
192 TARBALL="$tarball"
193 }
196 # Get package source. For SCM we are in cache so clone here and create a
197 # tarball here.
199 get_source() {
200 local url
201 url=${WGET_URL#*|}
202 set_paths
203 pwd=$(pwd)
204 case "$WGET_URL" in
205 http://*|ftp://*|https://*)
206 url="$MIRROR_URL/sources/packages/${TARBALL:0:1}/$TARBALL"
207 wget -T 60 -c -O $SRC/$TARBALL $WGET_URL ||
208 wget -T 60 -c -O $SRC/$TARBALL $url ||
209 die 'ERROR: %s' "wget $WGET_URL"
210 ;;
212 hg*|mercurial*)
213 _ 'Getting source from %s...' 'Hg'
214 _ 'URL: %s' "$url"
215 _ 'Cloning to "%s"' "$pwd/$pkgsrc"
216 if [ -n "$BRANCH" ]; then
217 _ 'Hg branch: %s' "$BRANCH"
218 hg clone $url --rev $BRANCH $pkgsrc ||
219 die 'ERROR: %s' "hg clone $url --rev $BRANCH"
220 else
221 hg clone $url $pkgsrc || die 'ERROR: %s' "hg clone $url"
222 fi
223 rm -rf $pkgsrc/.hg
224 create_tarball
225 ;;
227 git*)
228 _ 'Getting source from %s...' 'Git'
229 _ 'URL: %s' "$url"
230 cd $SRC
231 git clone $url $pkgsrc || die 'ERROR: %s' "git clone $url"
232 if [ -n "$BRANCH" ]; then
233 _ 'Git branch: %s' "$BRANCH"
234 cd $pkgsrc; git checkout $BRANCH; cd ..
235 fi
236 cd $SRC
237 create_tarball
238 ;;
240 cvs*)
241 mod=$PACKAGE
242 [ -n "$CVS_MODULE" ] && mod=$CVS_MODULE
243 _ 'Getting source from %s...' 'CVS'
244 _ 'URL: %s' "$url"
245 [ -n "$CVS_MODULE" ] && _ 'CVS module: %s' "$mod"
246 _ 'Cloning to "%s"' "$pwd/$mod"
247 cvs -d:$url co $mod && mv $mod $pkgsrc
248 create_tarball
249 ;;
251 svn*|subversion*)
252 _ 'Getting source from %s...' 'SVN'
253 _ 'URL: %s' "$url"
254 if [ -n "$BRANCH" ]; then
255 echo t | svn co $url -r $BRANCH $pkgsrc
256 else
257 echo t | svn co $url $pkgsrc
258 fi
259 create_tarball
260 ;;
262 bzr*)
263 _ 'Getting source from %s...' 'bazaar'
264 cd $SRC
265 pkgsrc=${url#*:}
266 if [ -n "$BRANCH" ]; then
267 echo "bzr -Ossl.cert_reqs=none branch $url -r $BRANCH"
268 bzr -Ossl.cert_reqs=none branch $url -r $BRANCH
269 else
270 echo "bzr -Ossl.cert_reqs=none branch $url"
271 bzr -Ossl.cert_reqs=none branch $url
272 cd $pkgsrc; BRANCH=$(bzr revno); cd ..
273 _ "Don't forget to add to receipt:"
274 echo -e "BRANCH=\"$BRANCH\"\n"
275 fi
276 mv $pkgsrc $pkgsrc-$BRANCH
277 pkgsrc="$pkgsrc-$BRANCH"
278 create_tarball
279 ;;
281 *)
282 broken; die 'ERROR: Unable to handle "%s"' "$WGET_URL"
283 ;;
284 esac
285 }
288 # Extract source package.
290 extract_source() {
291 if [ ! -s "$SRC/$TARBALL" ]; then
292 local url
293 url="$MIRROR_URL/sources/packages"
294 url="$url/${TARBALL:0:1}/$TARBALL"
295 _ 'Getting source from %s...' 'mirror'
296 _ 'URL: %s' "$url"
297 busybox wget -c -P $SRC $url || _ 'ERROR: %s' "wget $url"
298 fi
299 _ 'Extracting source archive "%s"' "$TARBALL"
300 case "$TARBALL" in
301 *.tar.gz|*.tgz) tar -xzf $SRC/$TARBALL 2>/dev/null ;;
302 *.tar.bz2|*.tbz|*.tbz2) tar -xjf $SRC/$TARBALL 2>/dev/null ;;
303 *.tar.lzma) tar -xaf $SRC/$TARBALL ;;
304 *.tar.lz|*.tlz) lzip -d < $SRC/$TARBALL | tar -xf - 2>/dev/null ;;
305 *.tar) tar -xf $SRC/$TARBALL ;;
306 *.zip|*.xpi) unzip -o $SRC/$TARBALL 2>/dev/null >&2;;
307 *.xz) unxz -c $SRC/$TARBALL | tar -xf - || \
308 tar -xf $SRC/$TARBALL 2>/dev/null;;
309 *.7z) 7zr x $SRC/$TARBALL 2>/dev/null >&2 ;;
310 *.Z|*.z) uncompress -c $SRC/$TARBALL | tar -xf - ;;
311 *.rpm) rpm2cpio $SRC/$TARBALL | cpio -idm --quiet ;;
312 *.run) /bin/sh $SRC/$TARBALL $RUN_OPTS ;;
313 *) cp $SRC/$TARBALL $(pwd) ;;
314 esac
315 }
318 # Display time.
320 disp_time() {
321 local sec div min
322 sec="$1"
323 div=$(( ($1 + 30) / 60))
324 case $div in
325 0) min='';;
326 # L10n: 'm' is for minutes (approximate cooking time)
327 *) min=$(_n ' ~ %dm' "$div");;
328 esac
330 # L10n: 's' is for seconds (cooking time)
331 _ '%ds%s' "$sec" "$min"
332 }
335 # Display cooked package summary.
337 summary() {
338 set_paths
339 cd $WOK/$pkg
340 [ -d $WOK/$pkg/install ] && prod=$(du -sh $WOK/$pkg/install | awk '{print $1}' 2>/dev/null)
341 [ -d $WOK/$pkg/source ] && srcdir=$(du -sh $WOK/$pkg/source | awk '{print $1}' 2>/dev/null)
342 [ -n "$TARBALL" ] && srcsize=$(du -sh $SRC/$TARBALL | awk '{print $1}')
344 _ 'Summary for: %s' "$PACKAGE $VERSION"
345 separator
347 # L10n: keep the same width of translations to get a consistent view
348 [ -n "$TARBALL" ] && _ 'Src file : %s' "$TARBALL"
349 [ -n "$srcsize" ] && _ 'Src size : %s' "$srcsize"
350 [ -n "$srcdir" ] && _ 'Source dir : %s' "$srcdir"
351 [ -n "$prod" ] && _ 'Produced : %s' "$prod"
352 _ 'Cook time : %s' "$(disp_time "$time")"
353 _ 'Cook date : %s' "$(date "$(_ '+%%F %%R')")"
354 _ 'Host arch : %s' "$ARCH"
356 separator -
357 _ ' # : Packed : Compressed : Files : Package name'
358 separator -
359 pkgi=1
360 for i in $(all_names); do
361 fs=$(du -sh $WOK/$pkg/taz/$i-$VERSION | awk '{print $1}')
362 pkgname="$i-$VERSION.tazpkg"
363 size=$(ls -lh $PKGS/$pkgname | awk '{print $5}')
364 files=$(wc -l < $WOK/$pkg/taz/$i-$VERSION/files.list)
365 printf "%2d : %7s : %10s : %5s : %s\n" "$pkgi" "$fs" "$size" "$files" "$pkgname"
366 pkgi=$((pkgi + 1))
367 done
368 separator
369 }
372 # Display debugging error info.
374 debug_info() {
375 title 'Debug information'
376 # L10n: specify your format of date and time (to help: man date)
377 # L10n: not bad one is '+%x %R'
378 _ 'Cook date: %s' "$(date "$(_ '+%%F %%R')")"
379 if [ -n "$time" ]; then
380 times="$(($(date +%s) - $time))"
381 _ 'Wasted time : %s' "$(disp_time "$times")"
382 fi
383 for error in \
384 ERROR 'No package' "cp: can't" "can't open" "can't cd" \
385 'error:' 'fatal error:' 'undefined reference to' \
386 'Unable to connect to' 'link: cannot find the library' \
387 'CMake Error' ': No such file or directory' \
388 'Could not read symbols: File in wrong format'
389 do
390 # format "line number:line content"
391 fgrep -n "$error" $LOGS/$pkg.log
392 done > $LOGS/$pkg.log.debug_info 2>&1
393 # sort by line number, remove duplicates
394 sort -gk1,1 -t: -u $LOGS/$pkg.log.debug_info
395 rm -f $LOGS/$pkg.log.debug_info
396 footer
397 }
400 # A bit smarter function than the classic `cp` command
402 scopy() {
403 if [ "$(stat -c %h -- "$1")" -eq 1 ]; then
404 cp -a "$1" "$2" # copy generic files
405 else
406 cp -al "$1" "$2" # copy hardlinks
407 fi
408 }
411 # Copy all generic files (locale, pixmaps, .desktop) from $install to $fs.
412 # We use standard paths, so some packages need to copy these files with the
413 # receipt and genpkg_rules.
414 # This function executes inside the packaging process, before compressor call.
416 copy_generic_files() {
417 # Proceed only for "main" package (for v2), and for any packages (v1)
418 [ "$pkg" == "$PACKAGE" ] || return 0
420 # $LOCALE is set in cook.conf
421 if [ -n "$LOCALE" -a -z "$WANTED" ]; then
422 if [ -d "$install/usr/share/locale" ]; then
423 mkdir -p "$fs/usr/share/locale"
424 for i in $LOCALE; do
425 if [ -d "$install/usr/share/locale/$i" ]; then
426 cp -r $install/usr/share/locale/$i $fs/usr/share/locale
427 fi
428 done
429 fi
430 fi
432 # Generic pixmaps copy can be disabled with COOKOPTS="!pixmaps" (or GENERIC_PIXMAPS="no")
433 if [ "${COOKOPTS/!pixmaps/}" == "$COOKOPTS" -a "$GENERIC_PIXMAPS" != 'no' ]; then
434 if [ -d "$install/usr/share/pixmaps" ]; then
435 mkdir -p "$fs/usr/share/pixmaps"
436 for i in png xpm; do
437 [ -f "$install/usr/share/pixmaps/$PACKAGE.$i" -a ! -f "$fs/usr/share/pixmaps/$PACKAGE.$i" ] &&
438 cp -r $install/usr/share/pixmaps/$PACKAGE.$i $fs/usr/share/pixmaps
439 done
440 fi
441 fi
443 # Desktop entry (.desktop).
444 # Generic desktop entry copy can be disabled with COOKOPTS="!menus" (or GENERIC_MENUS="no")
445 if [ "${COOKOPTS/!menus/}" == "$COOKOPTS" -a "$GENERIC_MENUS" != 'no' ]; then
446 if [ -d "$install/usr/share/applications" -a -z "$WANTED" ]; then
447 mkdir -p "$fs/usr/share"
448 cp -r $install/usr/share/applications $fs/usr/share
449 fi
450 fi
451 }
454 # Copy pixmaps, desktop files and licenses from $stuff to $install.
455 # This function executes after the main compile_rules() is done.
457 copy_generic_stuff() {
458 # Custom or homemade PNG pixmap can be in stuff.
459 if [ -f "$stuff/$PACKAGE.png" ]; then
460 mkdir -p $install/usr/share/pixmaps
461 cp $stuff/$PACKAGE.png $install/usr/share/pixmaps
462 fi
464 # Homemade desktop file(s) can be in stuff.
465 if [ -d "$stuff/applications" ]; then
466 mkdir -p $install/usr/share
467 cp -r $stuff/applications $install/usr/share
468 fi
469 if [ -f "$stuff/$PACKAGE.desktop" ]; then
470 mkdir -p $install/usr/share/applications
471 cp $stuff/$PACKAGE.desktop $install/usr/share/applications
472 fi
474 # Add custom licenses
475 if [ -d "$stuff/licenses" ]; then
476 mkdir -p $install/usr/share/licenses
477 cp -r $stuff/licenses $install/usr/share/licenses/$PACKAGE
478 fi
479 }
482 # Remove files provided by split packages
483 # For example:
484 # 1. Package "pkg-main":
485 # SPLIT="pkg-1 pkg-2 pkg-extra"
486 # 2. Package="pkg-extra":
487 # WANTED="pkg-main"
488 # BUILD_DEPENDS="pkg-1 pkg-2"
489 # cook_copy_folders usr
490 # cook_split_rm $BUILD_DEPENDS
492 cook_split_rm() {
493 for i in $@; do
494 action 'Remove files provided by split package %s...' "$i"
495 while read j; do
496 [ -f "$fs$j" -o -h "$fs$j" ] && rm $fs$j
497 rmdir "$(dirname "$fs$j")" 2>/dev/null
498 done < $WOK/$i/taz/$i-$VERSION/files.list
499 :; status
500 done
501 }
504 # Update installed.cook.diff
506 update_installed_cook_diff() {
507 # If a cook failed deps are removed.
508 cd $root$INSTALLED; ls -1 > $CACHE/installed.cook
509 cd $CACHE
510 [ "$1" == 'force' -o ! -s '/tmp/installed.cook.diff' ] && \
511 busybox diff installed.list installed.cook > /tmp/installed.cook.diff
512 deps=$(grep ^+[a-zA-Z0-9] /tmp/installed.cook.diff | wc -l)
513 }
516 # Remove installed deps.
518 remove_deps() {
519 # Now remove installed build deps.
520 diff='/tmp/installed.cook.diff'
521 [ -s "$diff" ] || return
523 deps=$(grep ^+[a-zA-Z0-9] $diff | sed 's|^+||')
524 nb=$(grep ^+[a-zA-Z0-9] $diff | wc -l)
525 newline
526 _n 'Build dependencies to remove:'; echo " $nb"
527 [ -n "$root" ] && echo "root=\"$root\""
528 {
529 _n 'Removing:'
530 for dep in $deps; do
531 echo -n " $dep"
532 # Do not waste time uninstalling the packages if we are inside
533 # aufs chroot - unmounting chroot will "uninstall" all packages.
534 [ -s /aufs-umount.sh ] ||
535 echo 'y' | tazpkg remove $dep --root=$root >/dev/null
536 done
537 } | busybox fold -sw80
538 newline; newline
539 # Keep the last diff for debug and info.
540 mv -f $diff $CACHE/installed.diff
541 }
544 # Automatically patch the sources.
546 patchit() {
547 [ -f "$stuff/patches/series" ] || return
549 IFS=$'\n'
550 while read i; do
551 patchname=$(echo ${i%%#*} | cut -d' ' -f1) # allow comments (anything after the # or space)
552 case $patchname in # allow patch options in form <options_no_spaces>|<file_name>
553 *\|*) patchopts="${patchname%|*}"; patchname="${patchname#*|}";;
554 *) patchopts='-Np1';;
555 esac
556 [ -n "$patchname" ] || continue # allow empty lines
557 [ -f "$src/done.$patchname" ] && continue # already applied (useful with `cook --continue`)
558 newline
559 _ 'Applying patch %s' "$patchname"
560 patch $patchopts -i $stuff/patches/$patchname | sed 's|^| |'
561 touch $src/done.$patchname
562 done < $stuff/patches/series
563 newline
564 unset IFS
565 }
568 # Check source tarball integrity.
570 check_integrity() {
571 for i in sha1 sha3 sha256 sha512 md5; do
572 I=$(echo $i | tr 'a-z' 'A-Z')
573 eval sum=\$TARBALL_$I
574 if [ -n "$sum" ]; then
575 newline
576 _ 'Checking %ssum of source tarball...' "$i"
577 echo "$sum $SRC/$TARBALL" | ${i}sum -c || exit 1
578 fi
579 done
580 newline
581 }
584 # The main cook function.
586 cookit() {
587 if [ -n "$SETUP_MD5" -a "$SETUP_MD5" != "$(ls $root$INSTALLED | md5sum | cut -c1-32)" ]; then
588 _ 'ERROR: Broken setup. Abort.'
589 return
590 fi
592 title 'Cook: %s' "$PACKAGE $VERSION"
593 set_paths
595 # Handle cross-tools.
596 case "$ARCH" in
597 arm*|x86_64)
598 # CROSS_COMPILE is used by at least Busybox and the kernel to set
599 # the cross-tools prefix. Sysroot is the root of our target arch
600 sysroot="$CROSS_TREE/sysroot"
601 tools="$CROSS_TREE/tools"
602 # Set root path when cross compiling. ARM tested but not x86_64
603 # When cross compiling we must install build deps in $sysroot.
604 arch="-$ARCH"
605 root="$sysroot"
606 _ '%s sysroot: %s' "$ARCH" "$sysroot"
607 _ 'Adding "%s" to PATH' "$tools/bin"
608 export PATH="$PATH:$tools/bin"
609 export PKG_CONFIG_PATH="$sysroot/usr/lib/pkgconfig"
610 export CROSS_COMPILE="$HOST_SYSTEM-"
611 _ 'Using cross-tools: %s' "$CROSS_COMPILE"
612 if [ "$ARCH" == 'x86_64' ]; then
613 export CC="$HOST_SYSTEM-gcc -m64"
614 export CXX="$HOST_SYSTEM-g++ -m64"
615 else
616 export CC="$HOST_SYSTEM-gcc"
617 export CXX="$HOST_SYSTEM-g++"
618 fi
619 export AR="$HOST_SYSTEM-ar"
620 export AS="$HOST_SYSTEM-as"
621 export RANLIB="$HOST_SYSTEM-ranlib"
622 export LD="$HOST_SYSTEM-ld"
623 export STRIP="$HOST_SYSTEM-strip"
624 export LIBTOOL="$HOST_SYSTEM-libtool"
625 ;;
626 esac
628 [ -n "$QA" ] && receipt_quality
630 cd $pkgdir
631 [ -z "$continue" ] && rm -rf source 2>/dev/null
632 rm -rf install taz 2>/dev/null
634 # Disable -pipe if less than 512 MB free RAM.
635 free=$(awk '/^MemFree|^Buffers|^Cached/{s+=$2}END{print int(s/1024)}' /proc/meminfo)
636 if [ "$free" -lt 512 ] && [ "$CFLAGS" != "${CFLAGS/-pipe}" ]; then
637 _ 'Disabling -pipe compile flag: %d MB RAM free' "$free"
638 CFLAGS="${CFLAGS/-pipe}"; CFLAGS=$(echo "$CFLAGS" | tr -s ' ')
639 CXXFLAGS="${CXXFLAGS/-pipe}"; CXXFLAGS=$(echo "$CXXFLAGS" | tr -s ' ')
640 fi
641 unset free
643 # Export flags and path to be used by make and receipt.
644 DESTDIR="$pkgdir/install"
645 # FIXME: L10n: Is this the right time for 'LC_ALL=C LANG=C'?
646 export DESTDIR MAKEFLAGS CFLAGS CXXFLAGS CONFIG_SITE LC_ALL=C LANG=C
647 #LDFLAGS
649 # BUILD_DEPENDS may vary depending on the ARCH
650 case "$ARCH" in
651 arm*) [ -n "$BUILD_DEPENDS_arm" ] && BUILD_DEPENDS=$BUILD_DEPENDS_arm ;;
652 x86_64) [ -n "$BUILD_DEPENDS_x86_64" ] && BUILD_DEPENDS=$BUILD_DEPENDS_x86_64 ;;
653 esac
655 # Check for build deps and handle implicit depends of *-dev packages
656 # (ex: libusb-dev :: libusb).
657 # rm -f $CACHE/installed.local $CACHE/installed.web $CACHE/missing.dep
658 # touch $CACHE/installed.local $CACHE/installed.web
659 [ -n "$BUILD_DEPENDS" ] && _ 'Checking build dependencies...'
660 [ -n "$root" ] && _ 'Using packages DB: %s' "$root$DB"
662 # Get the list of installed packages
663 cd $root$INSTALLED; ls > $CACHE/installed.list
665 for action in check install; do
666 for dep in $BUILD_DEPENDS; do
667 implicit="${dep%-dev}"; [ "$implicit" == "$dep" ] && implicit=''
668 for i in $dep $implicit; do
669 # Skip if package already installed
670 [ -f "$root$INSTALLED/$i/receipt" ] && continue
672 case $action in
673 check)
674 # Search for local package or local provided-package
675 name=$(awk -F$'\t' -vpkg="$i" '{
676 if (index(" " $1 " " $10 " ", " " pkg " ")) {print $1; exit}
677 }' "$PKGS/packages.info")
678 if [ -z "$name" ]; then
679 # Search for package in mirror
680 name="$(awk -F$'\t' -vi="$i" '$1==i{print $1; exit}' "$root$DB/packages.info")"
681 [ -z "$name" -a "$i" == "$dep" ] && die 'ERROR: unknown dep "%s"' "$i"
682 fi
683 ;;
684 install)
685 tazpkg get-install $i --root=$root --local --quiet --cookmode || { broken; exit 1; }
686 ;;
687 esac
688 done
689 done
690 done
692 # # Have we a missing build dep to cook?
693 # if [ -s "$CACHE/missing.dep" ] && [ -n "$AUTO_COOK" ]; then
694 # _ 'Auto cook config is set: %s' "$AUTO_COOK"
695 # cp -f $LOGS/$PACKAGE.log $LOGS/$PACKAGE.log.$$
696 # for i in $(uniq $CACHE/missing.dep); do
697 # (_ 'Building dep (wok/pkg) : %s' "$i $vers") | \
698 # tee -a $LOGS/$PACKAGE.log.$$
699 # # programmers: next two messages are exact copy from remove_deps()
700 # togrep1=$(_n 'Build dependencies to remove:')
701 # togrep2=$(_n 'Removing:')
702 # cook $i || (_ "ERROR: can't cook dep \"%s\"" "$i" && newline && \
703 # fgrep $togrep1 $LOGS/$i.log && \
704 # fgrep $togrep2 $LOGS/$i.log && newline) | \
705 # tee -a $LOGS/$PACKAGE.log.$$ && break
706 # done
707 # rm -f $CACHE/missing.dep
708 # mv $LOGS/$PACKAGE.log.$$ $LOGS/$PACKAGE.log
709 # fi
710 #
711 # # QA: Exit on missing dep errors. We exit in both cases, if AUTO_COOK
712 # # is enabled and cook fails we have ERROR in log, if no auto cook we have
713 # # missing dep in cached file.
714 # lerror=$(_n 'ERROR')
715 # if fgrep -q ^$lerror $LOGS/$pkg.log || [ -s "$CACHE/missing.dep" ]; then
716 # [ -s "$CACHE/missing.dep" ] && nb=$(wc -l < $CACHE/missing.dep)
717 # _p 'ERROR: missing %d dependency' 'ERROR: missing %d dependencies' "$nb" "$nb"
718 # broken; exit 1
719 # fi
720 #
721 # # Install local packages: package-version$arch
722 # cd $PKGS
723 # for i in $(uniq $CACHE/installed.local); do
724 # # _ 'Installing dep (pkg/local): %s' "$i"
725 # tazpkg install $i --root=$root --local --quiet --cookmode
726 # done
727 #
728 # # Install web or cached packages (if mirror is set to $PKGS we only
729 # # use local packages).
730 # for i in $(uniq $CACHE/installed.web); do
731 # # _ 'Installing dep (web/cache): %s' "$i"
732 # tazpkg get-install $i --root=$root --local --quiet --cookmode
733 # done
735 update_installed_cook_diff
737 # Get source tarball and make sure we have source dir named:
738 # $PACKAGE-$VERSION to be standard in receipts. Here we use tar.lzma
739 # tarball if it exists.
740 if [ -n "$WGET_URL" -a ! -f "$SRC/$TARBALL" ]; then
741 if [ -f "$SRC/${SOURCE:-$PACKAGE}-$VERSION.tar.lzma" ]; then
742 TARBALL="${SOURCE:-$PACKAGE}-$VERSION.tar.lzma"
743 LZMA_SRC=''
744 else
745 get_source || { broken; exit 1; }
746 fi
747 fi
748 if [ -z "$WANTED" -a -n "$TARBALL" -a ! -d "$src" ]; then
749 mkdir -p $pkgdir/source/tmp; cd $pkgdir/source/tmp
750 if ! extract_source ; then
751 get_source
752 extract_source || { broken; exit 1; }
753 fi
754 if [ -n "$LZMA_SRC" ]; then
755 cd $pkgdir/source
756 if [ "$(ls -A tmp | wc -l)" -gl 1 -o -f "$(echo tmp/*)" ]; then
757 mv tmp tmp-1; mkdir tmp
758 mv tmp-1 tmp/${SOURCE:-$PACKAGE}-$VERSION
759 fi
760 if [ -d "tmp/${SOURCE:-$PACKAGE}-$VERSION" ]; then
761 cd tmp; tar -c * | lzma e $SRC/$TARBALL -si
762 fi
763 fi
764 cd $pkgdir/source/tmp
765 # Some archives are not well done and don't extract to one dir (ex lzma).
766 files=$(ls | wc -l)
767 [ "$files" -eq 1 -a -d "$(ls)" ] && mv * ../$PACKAGE-$VERSION
768 [ "$files" -eq 1 -a -f "$(ls)" ] && mkdir -p ../$PACKAGE-$VERSION && \
769 mv * ../$PACKAGE-$VERSION/$TARBALL
770 [ "$files" -gt 1 ] && mkdir -p ../$PACKAGE-$VERSION && \
771 mv * ../$PACKAGE-$VERSION
772 cd ..; rm -rf tmp
773 fi
775 check_integrity
777 # Libtool shared libs path hack.
778 case "$ARCH" in
779 arm*) cross libhack ;;
780 esac
782 # Execute receipt rules.
783 if grep -q ^compile_rules $receipt; then
784 _ 'Executing: %s' 'compile_rules'
785 echo "CFLAGS : $CFLAGS"
786 #echo "LDFLAGS : $LDFLAGS"
787 [ -d "$src" ] && cd $src
788 patchit
789 compile_rules $@ || { broken; exit 1; }
790 # Stay compatible with _pkg
791 [ -d "$src/_pkg" ] && mv $src/_pkg $install
792 # QA: compile_rules success so valid.
793 mkdir -p $install
794 else
795 # QA: no compile_rules so no error, valid.
796 mkdir -p $install
797 fi
799 copy_generic_stuff
801 # Actions to do after compiling the package
802 # Skip all for split packages (already done in main package)
803 if [ -z "$WANTED" ]; then
804 footer
805 export COOKOPTS ARCH install; @@PREFIX@@/libexec/cookutils/compressor install
806 fi
807 footer
809 # Execute testsuite.
810 if grep -q ^testsuite $receipt; then
811 title 'Running testsuite'
812 testsuite $@ || { broken; exit 1; }
813 footer
814 fi
816 update_installed_cook_diff force
817 }
820 # Cook quality assurance.
822 cookit_quality() {
823 while true; do
824 [ ! -d "$WOK/$pkg/install" -a -z "$WANTED" ] || break
825 _ 'ERROR: cook failed' | tee -a $LOGS/$pkg.log
826 [ "$trials" == 'yes' ] || break
827 title "Interactive mode"
828 # TODO: allow commands:
829 # q - quit; v - edit receipt here using vi;
830 # s - search for package containing package;
831 # <package name> - install package; [Enter] - retry
832 _ 'You may install the packages here and/or edit the receipt there.'
833 newline
834 while true; do
835 _n 'Install the package? [name/N] '; read answer
836 [ -n "$answer" ] || break
837 tazpkg -gi $answer --root=$root --local --quiet --cookmode
838 done
839 newline
840 _n 'Try again? [Y/n] '; read answer
841 [ "$answer" == 'n' ] && break
842 # here you may append log if you want (">>" instead of last ">")
843 cookit $@ 2>&1 | loglimit 50 > $LOGS/$pkg.log
844 done
846 [ "${COOKOPTS/skip-log-errors/}" != "$COOKOPTS" ] && return 0
848 # ERROR can be echoed any time in cookit()
849 if grep -Ev "(conftest|configtest)" $LOGS/$pkg.log | \
850 grep -Eq "(^ERROR|undefined reference to)" ; then
851 debug_info | tee -a $LOGS/$pkg.log
852 put_status $pkg Failed
853 rm -f $command
854 broken; exit 1
855 fi
856 }
859 # Create the package. Wanted to use TazPkg to create a tazpkg package at first,
860 # but it doesn't handle EXTRAVERSION.
862 packit() {
863 set_paths "$1"
864 PACKAGE="${1:-$PACKAGE}"
866 # Handle cross compilation
867 case "$ARCH" in
868 arm*|x86_64) arch="-$ARCH" ;;
869 esac
871 title 'Pack: %s' "$PACKAGE $VERSION$arch"
873 if grep -q ^genpkg_rules $receipt; then
874 _ 'Executing: %s' 'genpkg_rules'
875 set -e; cd $pkgdir; mkdir -p $fs
876 genpkg_rules || (newline; _ 'ERROR: genpkg_rules failed'; newline) >> \
877 $LOGS/$pkg.log
878 else
879 _ 'No packages rules: meta package'
880 mkdir -p $fs
881 fi
883 # Check CONFIG_FILES
884 if [ -n "$CONFIG_FILES" ]; then
885 unset IFS
886 for i in $CONFIG_FILES; do
887 if [ ! -e $fs$i ]; then
888 case $i in
889 */) mkdir -p $fs$i ;;
890 *) mkdir -p $fs$(dirname $i); touch $fs$i ;;
891 esac
892 fi
893 done
894 fi
896 # First QA check to stop now if genpkg_rules failed.
897 lerror=$(_n 'ERROR')
898 if fgrep -q ^$lerror $LOGS/$pkg.log; then
899 broken; exit 1
900 fi
902 cd $taz
903 action 'Copying "%s"...' 'receipt'
904 export PACKAGE DEPENDS PROVIDE SUGGESTED TAZPANEL_DAEMON TAGS CAT
905 @@PREFIX@@/libexec/cookutils/mk_pkg_receipt "$(realpath ../receipt)" > $pack/receipt
906 chown 0.0 $pack/receipt; status
908 unset desc
909 [ "$pkg" == "$PACKAGE" -a -f "../description.txt" ] && desc="../description.txt"
910 [ -f "../description.$PACKAGE.txt" ] && desc="../description.$PACKAGE.txt"
911 if [ -n "$desc" ]; then
912 action 'Copying "%s"...' "$(basename "$desc")"
913 cp -f $desc $pack/description.txt; chown 0.0 $pack/description.txt; status
914 fi
916 copy_generic_files
918 # Strip and stuff files.
919 export COOKOPTS ARCH HOST_SYSTEM LOCALE fs; @@PREFIX@@/libexec/cookutils/compressor fs
921 # Create files.list with redirecting find output.
922 action 'Creating the list of files...'
923 cd $fs
924 find . -type f -print > ../files.list
925 find . -type l -print >> ../files.list
926 cd ..; sed -i 's|^.||' files.list
927 status
929 # Md5sum of files.
930 action 'Creating md5sum of files...'
931 while read file; do
932 [ -L "fs$file" ] && continue
933 [ -f "fs$file" ] || continue
934 case "$file" in
935 /lib/modules/*/modules.*|*.pyc) continue ;;
936 esac
937 md5sum "fs$file" | sed 's| fs| |'
938 done < files.list | sort -k2 > md5sum
939 status
941 UNPACKED_SIZE=$(du -chs fs receipt files.list md5sum description.txt \
942 2>/dev/null | awk 'END{ print $1 }')
944 # Build cpio archive.
945 action 'Compressing the FS...'
946 find fs -newer $receipt -exec touch -hr $receipt '{}' \;
947 find fs | cpio -o -H newc --quiet | lzma-alone e fs.cpio.lzma -si
948 # find fs | cpio -o -H newc --quiet | /bin/lzma -zeT0 -vv >fs.cpio.lzma
949 mv fs ../
950 status
952 PACKED_SIZE=$(du -chs fs.cpio.lzma receipt files.list md5sum description.txt \
953 2>/dev/null | awk 'END{ print $1 }')
955 action 'Updating receipt sizes...'
956 sed -i '/^PACKED_SIZE=/d; /^UNPACKED_SIZE=/d' receipt
957 sed -i "s|^PACKAGE=|PACKED_SIZE=\"$PACKED_SIZE\"\nUNPACKED_SIZE=\"$UNPACKED_SIZE\"\nPACKAGE=|" receipt
958 status
960 # Set extra version.
961 if [ -n "$EXTRAVERSION" ]; then
962 action 'Updating receipt EXTRAVERSION: %s' "$EXTRAVERSION"
963 sed -i '/^EXTRAVERSION=/d' receipt
964 sed -i "s|^VERSION=|EXTRAVERSION=\"$EXTRAVERSION\"\nVERSION=|" receipt
965 status
966 fi
968 # Compress.
969 action 'Creating full cpio archive...'
970 find . -newer $receipt -exec touch -hr $receipt '{}' \;
971 find . | cpio -o -H newc --quiet > ../$PACKAGE-$VERSION$EXTRAVERSION$arch.tazpkg
972 status
974 # action 'Restoring original package tree...'
975 mv ../fs .
976 # status
978 rm fs.cpio.lzma; cd ..
980 # QA and give info.
981 tazpkg=$(ls *.tazpkg)
982 packit_quality
983 footer "$(_ 'Package "%s" created' "$tazpkg")"
984 update_packages_db
985 }
988 # Calculate release checksum: usually it does not change on "just recook".
989 # Release checksum is md5sum of file containing md5sums of:
990 # a) all files, b) receipt, and c) description.txt.
991 # Md5sum of the package file will change every time because of embedded timestamps;
992 # release checksum based only on files content, and will change only when files change.
993 # (Pitfall: ownership and permissions...)
995 release_checksum() {
996 local pack=$1
997 local rsum_file=$(mktemp)
999 cp $pack/md5sum $rsum_file
1000 md5sum $pack/receipt | sed 's| [^ ]*/| |' >> $rsum_file
1001 [ -e "$pack/description.txt" ] &&
1002 md5sum $pack/description.txt | sed 's| [^ ]*/| |' >> $rsum_file
1004 local rsum=$(md5sum $rsum_file | awk '{print $1}')
1005 rm $rsum_file
1006 local rsumold=$(awk -F$'\t' -vpkg="$PACKAGE" '
1007 {if ($1 == pkg) { print $9; exit; }}' $PKGS/packages.info)
1009 [ "$rsum" == "$rsumold" ] && rsum=''
1011 echo $rsum
1015 # Verify package quality and consistency.
1017 packit_quality() {
1018 #action 'QA: checking for broken link...'
1019 #link=$(find $fs/usr -type l -follow)
1020 #[ "$link" ] && echo -e "\nERROR: broken link in filesystem"
1021 #status
1023 if [ "${COOKOPTS/skip-log-errors/}" == "$COOKOPTS" ]; then
1024 # Exit if any error found in log file.
1025 if fgrep -q ^ERROR $LOGS/$pkg.log; then
1026 rm -f $command
1027 broken; exit 1
1028 fi
1029 fi
1031 if [ "${COOKOPTS/empty-pkg/}" == "$COOKOPTS" ]; then
1032 action 'QA: checking for empty package...'
1033 if [ ! -s "$pack/files.list" -a "$CATEGORY" != 'meta' ]; then
1034 broken
1035 rm -f $command
1036 false; status
1037 die 'ERROR: empty package'
1038 fi
1039 :; status
1040 fi
1043 # Find and remove old package(s) only if "release checksum" has changed
1044 rsum=$(release_checksum $pack)
1045 if [ -n "$rsum" ]; then
1046 old_file=$(awk -F$'\t' -vname="$PACKAGE" '{
1047 if ($1 == name) printf("%s-%s.tazpkg", $1, $2);
1048 }' $PKGS/packages.info)
1049 if [ -f "$PKGS/$old_file" ]; then
1050 action 'Removing old package "%s"' "$old_file"
1051 rm -f "$PKGS/$old_file"
1052 status
1053 fi
1054 # package changed, substitute old package by new
1055 mv -f $pkgdir/taz/$PACKAGE-$VERSION$EXTRAVERSION.tazpkg $PKGS
1056 else
1057 # package not changed, remove new package
1058 rm -f $pkgdir/taz/$PACKAGE-$VERSION$EXTRAVERSION.tazpkg
1059 fi
1061 sed -i "/^${pkg}$/d" $broken
1062 #action 'Removing source tree...'
1063 #rm -f $WOK/$pkg/source; status
1067 # Return all the names of packages bundled in this receipt
1069 all_names() {
1070 local split=" $SPLIT "
1071 if ! head -n1 $WOK/$pkg/receipt | fgrep -q 'v2'; then
1072 # For receipts v1: $SPLIT may present in the $WANTED package,
1073 # but split packages have their own receipts
1074 echo $PACKAGE
1075 elif [ "${split/ $PACKAGE /}" != "$split" ]; then
1076 # $PACKAGE included somewhere in $SPLIT (probably in the end).
1077 # We should build packages in the order defined in the $SPLIT.
1078 echo $SPLIT
1079 else
1080 # We'll build the $PACKAGE, then all defined in the $SPLIT.
1081 echo $PACKAGE $SPLIT
1082 fi
1086 # v2: pack all packages using compiled files
1088 packall() {
1089 set_paths
1090 if head -n1 "$pkgdir/receipt" | fgrep -q 'v2'; then
1091 for i in $(all_names); do
1092 unset TAGS DEPENDS CAT CONFIG_FILES PROVIDE SUGGESTED DATABASE_FILES TAZPANEL_DAEMON
1093 packit $i
1094 done
1095 else
1096 packit
1097 fi
1101 # Reverse "cat" command: prints input lines in the reverse order
1103 tac() {
1104 sed '1!G;h;$!d' $1
1108 # Update chroot with freshly rebuilt package: keep env up-to-date.
1110 update_chroot() {
1111 local PACKAGE="$pkg"
1112 for i in $(all_names); do
1113 if [ -d "$root$INSTALLED/$i" ]; then
1114 . /etc/slitaz/cook.conf
1115 . $WOK/$pkg/taz/$i-$VERSION/receipt
1116 _ 'Updating %s chroot environment...' "$ARCH"
1117 _ 'Updating chroot: %s' "$i ($VERSION$EXTRAVERSION$arch)" | log
1118 cd $PKGS
1119 tazpkg install $i-$VERSION$EXTRAVERSION$arch.tazpkg --forced --root=$root
1120 fi
1121 done
1125 # Install package on --inst or update the chroot.
1127 install_package() {
1128 set_paths
1129 case "$ARCH" in
1130 arm*|x86_64)
1131 arch="-$ARCH"
1132 root="$CROSS_TREE/sysroot" ;;
1133 esac
1134 # Install package if requested but skip install if target host doesn't
1135 # match build system or it will break the build chroot.
1136 build=$(echo $BUILD_SYSTEM | cut -d- -f1)
1137 if [ -n "$inst" -a "$build" == "$ARCH" ]; then
1138 if [ -f "$PKGS/$PACKAGE-$VERSION$EXTRAVERSION.tazpkg" ]; then
1139 cd $PKGS
1140 tazpkg install $PACKAGE-$VERSION$EXTRAVERSION.tazpkg --forced
1141 else
1142 broken
1143 die 'Unable to install package, build has failed.'
1144 fi
1145 fi
1147 update_chroot
1151 # remove chroot jail
1153 umount_aufs() {
1154 tac ${1}rw/aufs-umount.sh | sh
1155 rm -rf ${1}rw
1156 umount ${1}root
1157 rmdir ${1}r*
1161 # Launch the cook command into a chroot jail protected by aufs.
1162 # The current filesystems are used read-only and updates are
1163 # stored in a separate branch.
1165 try_aufs_chroot() {
1167 base="/dev/shm/aufsmnt$$"
1169 # Can we setup the chroot? Is it already done?
1170 grep -q ^AUFS_NOT_SUPPORTED $receipt && return
1171 grep -q ^AUFS_NOT_RAMFS $receipt && base="/mnt/aufsmnt$$"
1172 [ -n "$AUFS_MOUNTS" -a ! -f /aufs-umount.sh ] || return
1173 grep -q ^aufs /proc/modules || modprobe aufs 2> /dev/null || return
1174 mkdir ${base}root ${base}rw || return
1176 _ 'Setup aufs chroot...'
1178 # Sanity check
1179 for i in / /proc /sys /dev/shm /home ; do
1180 case " $AUFS_MOUNTS " in
1181 *\ $i\ *) ;;
1182 *) AUFS_MOUNTS="$AUFS_MOUNTS $i" ;;
1183 esac
1184 done
1185 for mnt in $(ls -d $AUFS_MOUNTS | sort | uniq); do
1186 mount --bind $mnt ${base}root$mnt
1187 if [ $mnt == / ] && ! mount -t aufs -o br=${base}rw:/ none ${base}root; then
1188 _ 'Aufs mount failure'
1189 umount ${base}root
1190 rm -rf ${base}r*
1191 return
1192 fi
1193 echo "umount ${base}root$mnt" >> ${base}rw/aufs-umount.sh
1194 done
1195 trap "umount_aufs ${base}" INT
1197 chroot ${base}root $(cd $(dirname $0); pwd)/$(basename $0) "$@"
1198 status=$?
1200 _ 'Leaving aufs chroot...'
1201 umount_aufs $base
1202 # Install package outside the aufs jail
1203 install_package
1204 exit $status
1208 # Encode predefined XML entities
1210 xml_ent() {
1211 sed -e 's|&|\&amp;|g; s|<|\&lt;|g; s|>|\&gt;|g; s|"|\&quot;|g' -e "s|'|\&apos;|g"
1215 # Create a XML feed for freshly built packages.
1217 gen_rss() {
1218 pubdate=$(date '+%a, %d %b %Y %X')
1219 cat > $FEEDS/$pkg.xml <<EOT
1220 <item>
1221 <title>$PACKAGE $VERSION$EXTRAVERSION</title>
1222 <link>${COOKER_URL}?pkg=${PACKAGE//+/%2B}</link>
1223 <guid>$PACKAGE-$VERSION$EXTRAVERSION</guid>
1224 <pubDate>$pubdate</pubDate>
1225 <description>$(echo -n "$SHORT_DESC" | xml_ent)</description>
1226 </item>
1227 EOT
1231 # Truncate stdout log file to $1 Mb.
1233 loglimit() {
1234 if [ -n "$DEFAULT_LOG_LIMIT" ]; then
1235 tee /dev/stderr | head -qc ${1:-$DEFAULT_LOG_LIMIT}m
1236 else
1237 tee /dev/stderr
1238 fi
1243 # Receipt functions to ease packaging
1246 get_dev_files() {
1247 action 'Getting standard devel files...'
1248 mkdir -p $fs/usr/lib
1249 cp -a $install/usr/lib/pkgconfig $fs/usr/lib
1250 cp -a $install/usr/lib/*a $fs/usr/lib
1251 cp -a $install/usr/include $fs/usr
1252 status
1256 # Function to use in compile_rules() to copy man page from $src to $install
1258 cook_pick_manpages() {
1259 local name section
1260 action 'Copying man pages...'
1262 for i in $@; do
1263 name=$(echo $i | sed 's|\.[gbx]z2*$||')
1264 section=${name##*/}; section=${section##*.}
1265 mkdir -p $install/usr/share/man/man$section
1266 scopy $i $install/usr/share/man/man$section
1267 done
1268 status
1272 # Function to use in compile_rules() to copy documentation from $src to $install
1274 cook_pick_docs() {
1275 local docdir="$install/usr/share/doc/$PACKAGE-$VERSION"
1276 action 'Copying documentation...'
1277 mkdir -p $docdir
1278 cp -r $@ $docdir
1279 chmod -R a+r $docdir
1280 status
1284 # Function to use in genpkg_rules() to copy specified files from $install to $fs
1286 cook_copy_files() {
1287 action 'Copying files...'
1288 cd $install
1289 local i j
1290 IFS=$'\n'
1291 for i in $@; do
1292 for j in $(find . -name $i ! -type d); do
1293 mkdir -p $fs$(dirname ${j#.})
1294 scopy $j $fs$(dirname ${j#.})
1295 done
1296 done
1297 cd - >/dev/null
1298 status
1302 # Function to use in genpkg_rules() to copy specified folders from $install to $fs
1304 cook_copy_folders() {
1305 action 'Copying folders...'
1306 cd $install
1307 local i j
1308 IFS=$'\n'
1309 for i in $@; do
1310 for j in $(find . -name $i -type d); do
1311 mkdir -p $fs$(dirname ${j#.})
1312 cp -a $j $fs$(dirname ${j#.})
1313 done
1314 done
1315 cd - >/dev/null
1316 status
1320 # Remove from current $fs files that are already packed (for receipts v2).
1321 # Note: the order in $SPLIT is very important.
1323 remove_already_packed() {
1324 local i j
1325 IFS=$'\n'
1326 for i in $taz/*/files.list; do
1327 [ -e "$i" ] || continue
1328 while read j; do
1329 [ -f $fs$j -o -h $fs$j ] || continue
1330 rm $fs$j
1331 rmdir --parents --ignore-fail-on-non-empty $fs$(dirname $j)
1332 done < $i
1333 done
1334 unset IFS
1338 # Common function to copy files, folders and patterns
1340 copy() {
1341 action 'Copying folders and files...'
1342 local i j k filelist=$(mktemp) folderlist=$(mktemp)
1343 IFS=$'\n'
1344 cd $install
1345 find ! -type d | sed 's|\.||' > $filelist
1346 find -type d | sed 's|\.||' > $folderlist
1347 for i in $@; do
1348 case $i in
1349 @std)
1350 # Copy "standard" files (all but "developer files", man pages, documentation, translations)
1351 sed '/\.h$/d; /\.hxx$/d; /\.a$/d; /\.la$/d; /\.pc$/d; /\.pri$/d; /bin\/.*-config$/d;
1352 /\.m4$/d; /\.gir$/d; /\.typelib$/d; /\.vapi$/d; /\.deps$/d; /\.cmake$/d;
1353 /\/Makefile.*/d; /\.inc$/d; /\/include\//d;
1354 /\/share\/man\//d; /\/share\/doc\//d; /\/share\/gtk-doc\//d; /\/share\/info\//d;
1355 /\/share\/devhelp\//d; /\/share\/locale\//d;
1356 /\/share\/bash-completion\//d; /\/lib\/systemd\//d;
1357 /\/fonts\.scale$/d; /\/fonts\.dir$/d;
1358 /\/share\/appdata\//d; /\/share\/help\//d;
1359 /\/share\/icons\/hicolor\/[1236][245][68]*x[1236][245][68]*\//d; # 22, 24, 32, 64, 128, 256
1360 ' $filelist
1361 ;;
1362 @dev)
1363 # Copy "developer files"
1364 sed -n '/\.h$/p; /\.hxx$/p; /\.a$/p; /\.la$/p; /\.pc$/p; /\.pri$/p; /bin\/.*-config$/p;
1365 /\.m4$/p; /\.gir$/p; /\.typelib$/p; /\.vapi$/p; /\.deps$/p; /\.cmake$/p;
1366 /\/Makefile.*/p; /\.inc$/p; /\/include\//p;
1367 ' $filelist
1368 ;;
1369 @rm)
1370 remove_already_packed
1371 ;;
1372 */)
1373 # Copy specified folders.
1374 i="${i%/}"
1375 find -type d -path "*/${i#/}" | sed 's|^.||'
1376 ;;
1377 *)
1378 # Copy specified files.
1379 find ! -type d -path "*/${i#/}" | sed 's|^.||'
1380 ;;
1381 esac | sort -u | \
1382 while read j; do
1383 mkdir -p $fs$(dirname "$j")
1384 if [ -d "$install$j" ]; then
1385 cp -a "$install$j" $fs$(dirname "$j")
1386 else
1387 scopy "$install$j" $fs$(dirname "$j")
1388 fi
1389 done
1390 # Copy empty directories
1391 case $i in
1392 @std)
1393 while read j; do
1394 case $j in
1395 # always skip empty man folders, because this will end up
1396 # copying all the man pages to the package
1397 */man/*) continue;;
1398 esac
1399 [ -z "$(ls -A "$install$j")" ] || continue
1400 # directory $j is empty
1401 k="$j"
1402 # make 'ladder' from directories, from root dir to $j
1403 # /a /a/b /a/b/c etc.
1404 while :; do
1405 [ -z "$k" ] && break
1406 echo "$k"
1407 k="${k%/*}"
1408 done | tac | \
1409 # copy dir with its original ownership/permissions if it does not exist
1410 while read k; do
1411 [ -d "$fs$k" ] || cp -a "$install$k" "$fs$k"
1412 done
1413 done < $folderlist
1414 ;;
1415 esac
1416 done
1417 cd - >/dev/null
1418 unset IFS
1419 rm $filelist $folderlist
1420 status
1424 # Function to use in genpkg_rules() to copy hicolor icons in specified sizes
1425 # (default: 16 and 48) from $install to $fs
1427 cook_copy_icons() {
1428 local sizes=$@ i j
1429 action 'Copying hicolor icons...'
1430 [ -d "$fs/usr/share/icons/hicolor" ] && rm -rf "$fs/usr/share/icons/hicolor"
1431 mkdir -p $fs/usr/share/icons/hicolor
1432 for i in ${sizes:-16 48}; do
1433 j="${i}x$i"; [ "$i" == 'scalable' ] && j="$i"
1434 [ ! -e "$install/usr/share/icons/hicolor/$j" ] ||
1435 scopy $install/usr/share/icons/hicolor/$j \
1436 $fs/usr/share/icons/hicolor
1437 done
1438 status
1442 # Update packages database every time after successful build
1444 update_packages_db() {
1445 # packages.info (unsorted, located near to packages)
1446 local pi="$PKGS/packages.info"
1447 unset_receipt; . $pack/receipt
1448 SIZES=$(echo $PACKED_SIZE $UNPACKED_SIZE | sed 's|\.0||g')
1450 DEPENDS=$(echo $DEPENDS) # remove newlines, tabs and multiple spaces from variable
1452 rsum=$(release_checksum $pack)
1453 if [ -n "$rsum" ]; then
1454 _ 'The release checksum has changed.\n'
1456 sed -i "/^$PACKAGE\t/d" $pi # remove old entry
1457 cat >> $pi <<EOT
1458 $PACKAGE $VERSION$EXTRAVERSION $CATEGORY $SHORT_DESC $WEB_SITE $TAGS $SIZES $DEPENDS $rsum $PROVIDE
1459 EOT
1461 # files.list (uncompressed, unsorted, located in $cache)
1462 local fl="$cache/files.list"
1463 touch $fl
1464 sed -i "/^$PACKAGE: /d" $fl
1465 sed "s/^/$PACKAGE: \0/" $pack/files.list >> $fl
1466 else
1467 _ 'The release checksum has not changed.\n'
1468 fi
1472 # Update split.db once for receipt
1474 update_split_db() {
1475 local db="$cache/split.db"
1476 touch $db
1477 sed -i "/^$pkg\t/d" $db
1478 echo -e "$pkg\t$(all_names)" >> $db
1482 # Recreate whole split.db from scratch
1484 recreate_split_db() {
1485 # Clean
1486 local db="$cache/split.db"
1487 touch $db
1488 > $db
1490 cd $WOK
1491 for pkg in *; do
1492 [ -f "$WOK/$pkg/receipt" ] || continue
1493 unset PACKAGE SPLIT
1494 . $WOK/$pkg/receipt
1495 echo -e "$PACKAGE\t$(all_names)" >> $db
1496 done
1500 # Put the status to the activity log
1502 put_status() {
1503 # $1: package, $2: status, one of 'Done', 'Failed'
1504 sed -i "s|>$1</a>$|& [ $2 ]|" $activity
1511 # Commands
1514 # cook <package> --deps
1515 [ -n "$deps" ] && {
1516 @@PREFIX@@/libexec/cookutils/deps $1
1517 exit 0
1520 # cook <package> --clean
1521 # cook <package> -c
1522 [ -n "$clean" -o "$2" == '-c' ] && {
1523 action 'Cleaning "%s"' "$1"
1524 cd $WOK/$1; rm -rf install taz source
1525 status; newline
1526 touch $activity # update $activity -> something changed -> update webstat
1527 exit 0
1530 # cook <package> --getsrc
1531 # cook <package> -gs
1532 [ -n "$getsrc" -o "$2" == '-gs' ] && {
1533 title 'Getting source for "%s"' "$1"
1534 receipt="$WOK/$pkg/receipt"
1535 check_pkg_in_wok
1536 unset_receipt
1537 . $receipt
1538 get_source
1539 _ 'Tarball: %s' "$SRC/$TARBALL"; newline
1540 exit 0
1543 # cook <package> --block
1544 # cook <package> -b
1545 [ -n "$block" -o "$2" == '-b' ] && {
1546 action 'Blocking package "%s"' "$1"
1547 [ $(grep "^$1$" $blocked) ] || echo "$1" >> $blocked
1548 status; newline
1549 touch $activity
1550 exit 0
1553 # cook <package> --unblock
1554 # cook <package> -ub
1555 [ -n "$unblock" -o "$2" == '-ub' ] && {
1556 action 'Unblocking package "%s"' "$1"
1557 sed -i "/^$1$/d" $blocked
1558 status; newline
1559 touch $activity
1560 exit 0
1566 case "$1" in
1567 usage|help|-u|-h)
1568 usage ;;
1570 list-wok)
1571 title 'List of %s packages in "%s"' "$ARCH" "$WOK"
1572 cd $WOK
1573 if [ "$ARCH" != 'i486' ]; then
1574 count=0
1575 for pkg in $(fgrep 'HOST_ARCH=' */receipt | egrep "$ARCH|any" | cut -d: -f1)
1576 do
1577 unset HOST_ARCH
1578 . ./$pkg
1579 count=$(($count + 1))
1580 colorize 34 "$PACKAGE"
1581 done
1582 else
1583 count=$(ls | wc -l)
1584 ls -1
1585 fi
1586 footer "$(_p '%s package' '%s packages' "$count" "$(colorize 32 "$count")")"
1587 ;;
1589 activity)
1590 cat $activity ;;
1592 search)
1593 # Just a simple search function, we don't need more actually.
1594 query="$2"
1595 title 'Search results for "%s"' "$query"
1596 cd $WOK; ls -1 | grep "$query"
1597 footer ;;
1599 setup)
1600 # Setup a build environment
1601 check_root
1602 _ 'Cook: setup environment' | log
1603 title 'Setting up your environment'
1604 [ -d $SLITAZ ] || mkdir -p $SLITAZ
1605 cd $SLITAZ
1606 init_db_files
1607 _ 'Checking for packages to install...'
1608 # Use setup pkgs from cross.conf or cook.conf. When cross compiling
1609 # ARCH-setup or 'cross check' should be used before: cook setup
1610 case "$ARCH" in
1611 arm*|x86_64)
1612 [ -x '/usr/bin/cross' ] || die 'ERROR: %s is not installed' 'cross'
1613 _ 'Using config file: %s' '/etc/slitaz/cross.conf'
1614 . /etc/slitaz/cross.conf ;;
1615 esac
1616 for pkg in $SETUP_PKGS; do
1617 if [ -n "$forced" ]; then
1618 tazpkg -gi $pkg --forced
1619 else
1620 [ ! -d "$INSTALLED/$pkg" ] && tazpkg get-install $pkg
1621 fi
1622 done
1624 # Handle --options
1625 case "$2" in
1626 --wok) hg clone $WOK_URL wok || exit 1 ;;
1627 --stable) hg clone $WOK_URL-stable wok || exit 1 ;;
1628 --undigest) hg clone $WOK_URL-undigest wok || exit 1 ;;
1629 --tiny) hg clone $WOK_URL-tiny wok || exit 1 ;;
1630 esac
1632 # SliTaz group and permissions
1633 if ! grep -q ^slitaz /etc/group; then
1634 _ 'Adding group "%s"' 'slitaz'
1635 addgroup slitaz
1636 fi
1637 _ 'Setting permissions for group "%s"...' 'slitaz'
1638 find $SLITAZ -maxdepth 2 -exec chown root.slitaz {} \;
1639 find $SLITAZ -maxdepth 2 -exec chmod g+w {} \;
1640 footer "$(_ 'All done, ready to cook packages :-)')" ;;
1642 *-setup)
1643 # Setup for cross compiling.
1644 arch="${1%-setup}"
1645 check_root
1646 . /etc/slitaz/cook.conf
1647 for pkg in $CROSS_SETUP; do
1648 if [ -n "$forced" ]; then
1649 tazpkg -gi $pkg --forced
1650 else
1651 [ ! -d "$INSTALLED/$pkg" ] && tazpkg -gi $pkg
1652 fi
1653 done
1655 _ 'Cook: setup %s cross environment' "$arch" | log
1656 title 'Setting up your %s cross environment' "$arch"
1657 init_db_files
1658 sed -i \
1659 -e "s|ARCH=.*|ARCH=\"$arch\"|" \
1660 -e "s|CROSS_TREE=.*|CROSS_TREE=\"/cross/$arch\"|" \
1661 -e 's|BUILD_SYSTEM=.*|BUILD_SYSTEM=i486-slitaz-linux|' \
1662 /etc/slitaz/cook.conf
1663 case "$arch" in
1664 arm)
1665 flags='-O2 -march=armv6'
1666 host="$ARCH-slitaz-linux-gnueabi" ;;
1667 armv6hf)
1668 flags='-O2 -march=armv6j -mfpu=vfp -mfloat-abi=hard'
1669 host="$ARCH-slitaz-linux-gnueabi" ;;
1670 armv7)
1671 flags='-Os -march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=softfp -pipe'
1672 host="$ARCH-slitaz-linux-gnueabi" ;;
1673 x86_64)
1674 flags='-O2 -mtune=generic -pipe'
1675 host="$ARCH-slitaz-linux" ;;
1676 esac
1677 sed -i \
1678 -e "s|CFLAGS=.*|CFLAGS=\"$flags\"|" \
1679 -e "s|HOST_SYSTEM=.*|HOST_SYSTEM=$host|" /etc/slitaz/cook.conf
1680 . /etc/slitaz/cook.conf
1681 sysroot="$CROSS_TREE/sysroot"
1682 tools="/cross/$arch/tools"
1683 root="$sysroot"
1684 # L10n: keep the same width of translations to get a consistent view
1685 _ 'Target arch : %s' "$ARCH"
1686 _ 'Configure args : %s' "$CONFIGURE_ARGS"
1687 _ 'Build flags : %s' "$flags"
1688 _ 'Arch sysroot : %s' "$sysroot"
1689 _ 'Tools prefix : %s' "$tools/bin"
1690 # Tell the packages manager where to find packages.
1691 _ 'Packages DB : %s' "$root$DB"
1692 mkdir -p $root$INSTALLED
1693 cd $root$DB; rm -f *.bak
1694 for list in packages.list packages.desc packages.equiv packages.md5; do
1695 rm -f $list
1696 ln -s $SLITAZ/packages/$list $list
1697 done
1698 # We must have the cross compiled glibc-base installed or default
1699 # i486 package will be used as dep by tazpkg and then break the
1700 # cross environment
1701 if [ ! -f "$root$INSTALLED/glibc-base/receipt" ]; then
1702 colorize 36 $(_ 'WARNING: %s is not installed in sysroot' '(e)glibc-base')
1703 fi
1704 # Show GCC version or warn if not yet compiled.
1705 if [ -x "$tools/bin/$HOST_SYSTEM-gcc" ]; then
1706 _ 'Cross compiler : %s' "$HOST_SYSTEM-gcc"
1707 else
1708 colorize 36 $(_ 'C compiler "%s" is missing' "$HOST_SYSTEM-gcc")
1709 _ 'Run "%s" to cook a toolchain' 'cross compile'
1710 fi
1711 footer ;;
1713 test)
1714 # Test a cook environment.
1715 _ 'Cook test: testing the cook environment' | log
1716 [ ! -d "$WOK" ] && exit 1
1717 [ ! -d "$WOK/cooktest" ] && cp -r $DATA/cooktest $WOK
1718 cook cooktest ;;
1720 new)
1721 # Create the package folder and an empty receipt.
1722 pkg="$2"
1723 [ -z "$pkg" ] && usage
1724 newline
1725 [ -d "$WOK/$pkg" ] && die 'Package "%s" already exists.' "$pkg"
1727 action 'Creating folder "%s"' "$WOK/$pkg"
1728 mkdir $WOK/$pkg; cd $WOK/$pkg; status
1730 action 'Preparing the package receipt...'
1731 cp $DATA/receipt .
1732 sed -i "s|^PACKAGE=.*|PACKAGE=\"$pkg\"|" receipt
1733 status; newline
1735 # Interactive mode, asking and seding.
1736 case "$3" in
1737 --interactive|-x)
1738 _ 'Entering interactive mode...'
1739 separator
1740 _ 'Package : %s' "$pkg"
1742 _n 'Version : ' ; read answer
1743 sed -i "s|^VERSION=.*|VERSION=\"$answer\"|" receipt
1745 _n 'Category : ' ; read answer
1746 sed -i "s|^CATEGORY=.*|CATEGORY=\"$answer\"|" receipt
1748 # L10n: Short description
1749 _n 'Short desc : ' ; read answer
1750 sed -i "s|^SHORT_DESC=.*|SHORT_DESC=\"$answer\"|" receipt
1752 _n 'Maintainer : ' ; read answer
1753 sed -i "s|^MAINTAINER=.*|MAINTAINER=\"$answer\"|" receipt
1755 _n 'License : ' ; read answer
1756 sed -i "s|^LICENSE=.*|LICENSE=\"$answer\"|" receipt
1758 _n 'Web site : ' ; read answer
1759 sed -i "s|^WEB_SITE=.*|WEB_SITE=\"$answer\"|" receipt
1760 newline
1762 # Wget URL.
1763 _ 'Wget URL to download source tarball.'
1764 _n 'Example : ' ; echo '$GNU_MIRROR/$PACKAGE/$TARBALL'
1765 _n 'Wget url : ' ; read answer
1766 sed -i "s|^WGET_URL=.*|WGET_URL=\"$answer\"|" receipt
1768 # Ask for a stuff dir.
1769 confirm "$(_n 'Do you need a stuff directory? (y/N)')"
1770 if [ "$?" -eq 0 ]; then
1771 action 'Creating the stuff directory...'
1772 mkdir $WOK/$pkg/stuff; status
1773 fi
1775 # Ask for a description file.
1776 confirm "$(_n 'Are you going to write a description? (y/N)')"
1777 if [ "$?" -eq 0 ]; then
1778 action 'Creating the "%s" file...' 'description.txt'
1779 touch $WOK/$pkg/description.txt; status
1780 fi
1782 footer "$(_ 'Receipt is ready to use.')" ;;
1783 esac ;;
1785 list)
1786 # Cook a list of packages (better use the Cooker since it will order
1787 # packages before executing cook).
1788 check_root
1789 [ -z "$2" ] && die 'No list in argument.'
1790 [ -f "$2" ] || die 'List "%s" not found.' "$2"
1792 _ 'Starting cooking the list "%s"' "$2" | log
1794 while read pkg; do
1795 cook $pkg || broken
1796 done < $2
1797 ;;
1799 clean-wok)
1800 check_root
1801 newline; action 'Cleaning all packages files...'
1802 rm -rf $WOK/*/taz $WOK/*/install $WOK/*/source
1803 status; newline ;;
1805 clean-src)
1806 check_root
1807 newline; action 'Cleaning all packages sources...'
1808 rm -rf $WOK/*/source
1809 status; newline ;;
1811 uncook)
1812 cd $WOK
1813 count=0
1814 title 'Checking for uncooked packages'
1816 for i in *; do
1817 unset HOST_ARCH EXTRAVERSION
1818 [ ! -e $i/receipt ] && continue
1819 . ./$i/receipt
1820 # Source cooked pkg receipt to get EXTRAVERSION
1821 if [ -d "$WOK/$i/taz" ]; then
1822 cd $WOK/$i/taz/$(ls $WOK/$i/taz/ | head -n1)
1823 . ./receipt; cd $WOK
1824 fi
1825 case "$ARCH" in
1826 i486)
1827 debug "$(_ 'Package "%s"' "$PKGS/$PACKAGE-$VERSION$EXTRAVERSION.tazpkg")"
1828 if [ ! -f "$PKGS/$PACKAGE-$VERSION$EXTRAVERSION.tazpkg" ]; then
1829 count=$(($count + 1))
1830 colorize 34 "$i"
1831 fi ;;
1832 arm*)
1833 # Check only packages included in arch
1834 if echo "$HOST_ARCH" | egrep -q "$ARCH|any"; then
1835 # *.tazpkg
1836 if [ ! -f "$PKGS/$PACKAGE-$VERSION$EXTRAVERSION-$ARCH.tazpkg" ]; then
1837 count=$(($count + 1))
1838 colorize 34 "$i"
1839 fi
1840 fi ;;
1841 esac
1842 done
1844 if [ "$count" -gt 0 ]; then
1845 footer "$(_p '%s uncooked package' '%s uncooked packages' "$count" "$(colorize 31 "$count")")"
1846 else
1847 _ 'All packages are cooked :-)'
1848 newline
1849 fi
1850 ;;
1852 pkgdb)
1853 # Create suitable packages list for TazPkg and only for built packages
1854 # as well as flavors files for TazLiTo. We don't need logs since we do it
1855 # manually to ensure everything is fine before syncing the mirror.
1856 recreate_split_db
1857 @@PREFIX@@/libexec/cookutils/pkgdb "$2"
1858 ;;
1860 splitdb)
1861 # File split.db is useful for searching for split packages.
1862 recreate_split_db
1863 ;;
1865 *)
1866 # Just cook and generate a package.
1867 check_root
1868 time=$(date +%s)
1869 pkg="$1"
1870 [ -z "$pkg" ] && usage
1872 # Search last successful cook time in all logs from newer to older
1873 for i in '' $(seq 0 9 | sed 's|^|.|'); do
1874 [ -f "$LOGS/$pkg.log$i" ] || break
1875 lastcooktime=$(sed '/^Cook time/!d; s|.*: *\([0-9]*\)s.*|\1|' \
1876 $LOGS/$pkg.log$i 2>/dev/null | sed '$!d')
1877 [ -n "$lastcooktime" ] && break
1878 done
1880 receipt="$WOK/$pkg/receipt"
1881 check_pkg_in_wok
1882 newline
1884 unset inst
1885 unset_receipt
1886 . $receipt
1888 # Handle cross compilation.
1889 case "$ARCH" in
1890 arm*)
1891 if [ -z "$HOST_ARCH" ]; then
1892 _ 'cook: HOST_ARCH is not set in "%s" receipt' "$pkg"
1893 error="$(_ 'package "%s" is not included in %s' "$pkg" "$ARCH")"
1894 _ 'cook: %s' "$error"
1895 [ -n "$CROSS_BUGS" ] && _ 'bugs: %s' "$CROSS_BUGS"
1896 _ 'Cook skip: %s' "$error" | log
1897 newline
1898 broken; exit 1
1899 fi ;;
1900 esac
1902 # Some packages are not included in some arch or fail to cross compile.
1903 : ${HOST_ARCH=i486}
1904 debug "$(_ 'Host arch %s' "$HOST_ARCH")"
1905 # Handle arm{v6hf,v7,..}
1906 if ! $(echo "$HOST_ARCH" | egrep -q "${ARCH%v[0-9]*}|any"); then
1907 _ 'cook: %s' "HOST_ARCH=$HOST_ARCH"
1908 error="$(_ "package \"%s\" doesn't cook or is not included in %s" "$pkg" "$ARCH")"
1909 _ 'cook: %s' "error"
1910 [ -n "$CROSS_BUGS" ] && _ 'bugs: %s' "$CROSS_BUGS"
1911 _ 'Cook skip: %s' "$error" | log
1912 sed -i "/^${pkg}$/d" $broken
1913 newline
1914 exit 0
1915 fi
1917 # Skip blocked, 3 lines also for the Cooker.
1918 grep -q "^$pkg$" $blocked && [ "$2" != '--unblock' ] &&
1919 die 'Package "%s" is blocked' "$pkg"
1921 try_aufs_chroot "$@"
1923 # Log and source receipt.
1924 _ 'Cook started for: %s' "<a href='cooker.cgi?pkg=${pkg//+/%2B}'>$pkg</a>" | log
1925 echo "cook:$pkg" > $command
1927 [ -n "$lastcooktime" ] && echo "cook:$pkg $lastcooktime $(date +%s)" >> $cooktime
1929 while read cmd duration start; do
1930 [ $(($start + $duration)) -lt $(date +%s) ] &&
1931 echo "sed -i '/^$cmd $duration/d' $cooktime"
1932 done < $cooktime | sh
1934 # Display and log info if cook process stopped.
1935 # FIXME: gettext not working (in single quotes) here!
1936 trap '_ "\n\nCook stopped: control-C\n\n" | \
1937 tee -a $LOGS/$pkg.log' INT
1939 update_split_db
1941 # Handle --options
1942 case "$2" in
1943 --install|-i)
1944 inst='yes' ;;
1946 --pack)
1947 [ -d "$WOK/$pkg/install" ] || die 'Need to build "%s"' "$pkg"
1948 [ ! -d "$WOK/$pkg/taz" ] || rm -rf "$WOK/$pkg/taz"
1949 [ ! -f "$LOGS/$pkg-pack.log" ] || rm -rf $LOGS/$pkg-pack.log
1950 sed -i '$ s|$| (packing)|' $activity
1951 packall 2>&1 | tee -a $LOGS/$pkg-pack.log
1952 clean_log "$pkg-pack"
1953 time=$(($(date +%s) - $time))
1954 summary | sed 's|^Cook |Pack |' | tee -a $LOGS/$pkg-pack.log
1955 put_status $pkg Done
1956 rm -f $command
1957 exit 0 ;;
1959 --trials|-t)
1960 trials='yes' ;;
1961 esac
1963 # Rotate log
1964 for i in $(seq 9 -1 1); do
1965 j=$(($i - 1))
1966 [ -e $LOGS/$pkg.log.$j ] && mv -f $LOGS/$pkg.log.$j $LOGS/$pkg.log.$i
1967 done
1968 [ -e $LOGS/$pkg.log ] && mv $LOGS/$pkg.log $LOGS/$pkg.log.0
1970 # Check if wanted is built now so we have separate log files.
1971 for wanted in $WANTED ; do
1972 if grep -q "^$wanted$" $blocked; then
1973 broken
1974 rm -f $command
1975 die 'WANTED package "%s" is blocked' "$wanted"
1976 fi
1977 if grep -q "^$wanted$" $broken; then
1978 broken
1979 rm -f $command
1980 die 'WANTED package "%s" is broken' "$wanted"
1981 fi
1982 if [ ! -d "$WOK/$wanted/install" ]; then
1983 cook "$wanted" || { broken; exit 1; }
1984 fi
1985 done
1987 # Cook and pack or exit on error and log everything.
1988 cookit $@ 2>&1 | loglimit 50 > $LOGS/$pkg.log
1989 remove_deps | tee -a $LOGS/$pkg.log
1990 cookit_quality
1991 packall 2>&1 | loglimit 5 >> $LOGS/$pkg.log
1992 clean_log
1994 # Exit if any error in packing.
1995 if [ "${COOKOPTS/skip-log-errors/}" == "$COOKOPTS" ] &&
1996 grep -Ev "(/root/.cvspass|conftest|df: /|rm: can't remove)" $LOGS/$pkg.log | \
1997 grep -Eq "(^ERROR|: No such file or directory|not remade because of errors|ake: \*\*\* .* Error)"; then
1998 debug_info | tee -a $LOGS/$pkg.log
1999 put_status $pkg Failed
2000 rm -f $command
2001 broken; exit 1
2002 fi
2004 # Create an XML feed
2005 gen_rss
2007 # Time and summary
2008 time=$(($(date +%s) - $time))
2009 summary | tee -a $LOGS/$pkg.log
2010 newline
2012 # We may want to install/update (outside aufs jail!).
2013 [ -s /aufs-umount.sh ] || install_package
2015 put_status $pkg Done
2017 # Finally we DON'T WANT to build the *-dev or packages with WANTED="$pkg"
2018 # If you want automation, use the Cooker Build Bot.
2019 rm -f $command
2020 ;;
2021 esac
2023 exit 0